package ca.recrown.islandsurvivalcraft.interaction.commands.runnables;

import org.bukkit.ChatColor;
import org.bukkit.command.CommandSender;

import ca.recrown.islandsurvivalcraft.IslandSurvivalCraft;
import ca.recrown.islandsurvivalcraft.interaction.commands.RegisteredCommands;

public class HelpCommand implements CommandRunnable {
    private String helpMessage;
    @Override
    public String getDescription() {
        return "Displays these help messages.";
    }

    @Override
    public boolean invoke(CommandSender sender, String[] args) {
        if (args == null || args.length == 0) {
            sender.sendMessage(helpMessage);
            return true;
        } else {
            RegisteredCommands command = null;
            try {
                command = RegisteredCommands.valueOf(args[0].toUpperCase());
            } catch (IllegalArgumentException e) {
                return false;
            }
            StringBuilder sb = new StringBuilder();
            sb.append(ChatColor.YELLOW + args[0]);
            sb.append(": " + ChatColor.GRAY);
            sb.append(command.getCommandRunnable().getDescription());
            sb.append("\n" + ChatColor.WHITE);
            sb.append(command.getCommandRunnable().getDetailedDescription());
            sender.sendMessage(sb.toString().trim());
        }
        return true;
    }

    @Override
    public void initialize(IslandSurvivalCraft islandSurvivalCraft) {
        StringBuilder stringBuilder = new StringBuilder();
        RegisteredCommands[] commands = RegisteredCommands.values();
        stringBuilder.append(ChatColor.YELLOW + "IslandSurvivalCraft Commands:\n");
        for (int i = 0; i < commands.length; i++) {
            stringBuilder.append(ChatColor.GREEN + commands[i].toString());
            stringBuilder.append(": " + ChatColor.WHITE);
            stringBuilder.append(commands[i].getCommandRunnable().getDescription());
            stringBuilder.append("\n");
        }
        helpMessage = stringBuilder.toString().trim();
    }

    @Override
    public String getDetailedDescription() {
        return " \"islandsurvivalcraft help [command]\". Where [command] is a listed command, can optionally be added to get a detailed look at the command. Help is a command that lists all the other potential commands that may be run. Can also look at the detailed commands. But you knew this since your using help with help...";
    }

    @Override
    public boolean requiresInitialization() {
        return helpMessage == null;
    }
    
}